using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Terraria;
using Terraria.ID;
using Terraria.ModLoader;
using static Terraria.ModLoader.ModContent;

namespace ConciseGuns.Items
{
	public class CGClips : ModItem
	{
		public override void SetStaticDefaults() {
			DisplayName.SetDefault("Fastening Clips");
			Tooltip.SetDefault("Bronze fasteners + iron support + a cheap can of spray paint equals... corrosion resistance?");
		}
	
		public override void SetDefaults() {
			item.width = 14;
			item.height = 14;
			item.maxStack = 999;
			item.value = 1000;
			item.rare = 2;
		}

		public override void AddRecipes()
		{
			ModRecipe recipe = new ModRecipe(mod);
			recipe.AddIngredient(ItemID.IronBar, 2);
			recipe.AddIngredient(mod.GetItem("CGNut"), 4);
			recipe.AddIngredient(mod.GetItem("CGBolt"), 2);
			recipe.AddTile(TileID.Anvils);
			recipe.SetResult(this, 2);
			recipe.AddRecipe();

			recipe = new ModRecipe(mod);
			recipe.AddIngredient(ItemID.IronBar, 2);
			recipe.AddIngredient(mod.GetItem("CGFastener"), 2);
			recipe.AddTile(TileID.Anvils);
			recipe.SetResult(this, 2);
			recipe.AddRecipe();
		}
	}
}