using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Terraria;
using Terraria.ID;
using Terraria.ModLoader;
using static Terraria.ModLoader.ModContent;

namespace ConciseGuns.Items
{
	public class P05 : ModItem
	{
		public override void SetStaticDefaults() {
			DisplayName.SetDefault("P05 Mark I");
			Tooltip.SetDefault("It gets better. I promise."
				+ "\n15% chance to not consume ammo.");
		}
	
		public override void SetDefaults() {
			item.damage = 26;
			item.ranged = true;
			item.width = 5;
			item.height = 5;
			item.scale = 0.7f;
			item.useTime = 20;
			item.useAnimation = 20;
			item.useStyle = 5;
			item.noMelee = true;
			item.knockBack = 6;
			item.value = 10000;
			item.rare = 2;
			item.UseSound = SoundID.Item11;
			item.autoReuse = false;
			item.shoot = 10;
			item.shootSpeed = 16f;
			item.useAmmo = AmmoID.Bullet;
			item.UseSound = mod.GetLegacySoundSlot(SoundType.Item, "Sounds/Item/sound");
		}				
		public override bool ConsumeAmmo(Player player)
		{
			return Main.rand.NextFloat() >= .15f;
		}

		public override bool Shoot(Player player, ref Vector2 position, ref float speedX, ref float speedY, ref int type, ref int damage, ref float knockBack)
		{
			Vector2 perturbedSpeed = new Vector2(speedX, speedY).RotatedByRandom(MathHelper.ToRadians(5));
			speedX = perturbedSpeed.X;
			speedY = perturbedSpeed.Y;
			return true;
		}

		public override Vector2? HoldoutOffset()
		{
			return new Vector2(6, 1);
		}

		public override void AddRecipes()
		{
			ModRecipe recipe = new ModRecipe(mod);
			recipe.AddIngredient(ItemID.Handgun);
			recipe.AddIngredient(ItemID.CobaltShield);
			recipe.AddIngredient(ItemID.DemoniteBar, 7);
			recipe.AddTile(TileID.Anvils);
			recipe.SetResult(this);
			recipe.AddRecipe();
		
		    recipe = new ModRecipe(mod);
			recipe.AddIngredient(ItemID.Handgun);
			recipe.AddIngredient(ItemID.CobaltShield);
			recipe.AddIngredient(ItemID.CrimtaneBar, 7);
			recipe.AddTile(TileID.Anvils);
			recipe.SetResult(this);
			recipe.AddRecipe();
		}
	}
}