using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Terraria;
using Terraria.ID;
using Terraria.ModLoader;
using static Terraria.ModLoader.ModContent;

namespace ConciseGuns.Items
{
	public class P05Mark2A : ModItem
	{
		public override void SetStaticDefaults() {
			DisplayName.SetDefault("P05 Mark II-A");
			Tooltip.SetDefault("Reflex sight? I reflex-might. (I'll stop now.)"
				+ "\nYour improved accuracy ensures a +6% critical hit chance.");
		}
	
		public override void SetDefaults() {
			item.damage = 30;
			item.crit = 6;
			item.ranged = true;
			item.width = 5;
			item.height = 5;
			item.scale = 0.7f;
			item.useTime = 14;
			item.useAnimation = 14;
			item.useStyle = 5;
			item.noMelee = true;
			item.knockBack = 6;
			item.value = 20000;
			item.rare = 3;
			item.UseSound = SoundID.Item11;
			item.autoReuse = false;
			item.shoot = 10;
			item.shootSpeed = 16f;
			item.useAmmo = AmmoID.Bullet;
			item.UseSound = mod.GetLegacySoundSlot(SoundType.Item, "Sounds/Item/sound");
		}				
		public override bool ConsumeAmmo(Player player)
		{
			return Main.rand.NextFloat() >= .20f;
		}

		public override bool Shoot(Player player, ref Vector2 position, ref float speedX, ref float speedY, ref int type, ref int damage, ref float knockBack)
		{
			Vector2 perturbedSpeed = new Vector2(speedX, speedY).RotatedByRandom(MathHelper.ToRadians(3));
			speedX = perturbedSpeed.X;
			speedY = perturbedSpeed.Y;
			return true;
		}

		public override Vector2? HoldoutOffset()
		{
			return new Vector2(6, 1);
		}

		public override void AddRecipes()
		{
			ModRecipe recipe = new ModRecipe(mod);
			recipe.AddIngredient(mod.GetItem("P05Mark2"));
			recipe.AddIngredient(mod.GetItem("CGAccuracyPKG"));
			recipe.AddTile(TileID.WorkBenches);
			recipe.SetResult(this);
			recipe.AddRecipe();

			recipe = new ModRecipe(mod);
			recipe.AddIngredient(mod.GetItem("P05A"));
			recipe.AddIngredient(ItemID.MeteoriteBar, 7);
			recipe.AddTile(TileID.Anvils);
			recipe.SetResult(this);
			recipe.AddRecipe();
			
			recipe = new ModRecipe(mod);
			recipe.AddIngredient(mod.GetItem("P05"));
			recipe.AddIngredient(mod.GetItem("CGAccuracyPKG"));
			recipe.AddIngredient(ItemID.CrimtaneBar, 7);
			recipe.AddIngredient(ItemID.MeteoriteBar, 7);
			recipe.AddTile(TileID.Anvils);
			recipe.SetResult(this);
			recipe.AddRecipe();

			recipe = new ModRecipe(mod);
			recipe.AddIngredient(mod.GetItem("P05"));
			recipe.AddIngredient(mod.GetItem("CGAccuracyPKG"));
			recipe.AddIngredient(ItemID.DemoniteBar, 7);
			recipe.AddIngredient(ItemID.MeteoriteBar, 7);
			recipe.AddTile(TileID.Anvils);
			recipe.SetResult(this);
			recipe.AddRecipe();
		}
	}
}