using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Terraria;
using Terraria.ID;
using Terraria.ModLoader;
using static Terraria.ModLoader.ModContent;

namespace ConciseGuns.Items
{
	public class P05Mark3 : ModItem
	{
		public override void SetStaticDefaults() {
			DisplayName.SetDefault("P05 Mark III");
			Tooltip.SetDefault("Your patience is rewarded... hopefully."
				+ "\n25% chance not to consume ammo.");
		}
	
		public override void SetDefaults() {
			item.damage = 50;
			item.crit = 6;
			item.ranged = true;
			item.width = 5;
			item.height = 5;
			item.scale = 0.7f;
			item.useTime = 12;
			item.useAnimation = 12;
			item.useStyle = 5;
			item.noMelee = true;
			item.knockBack = 0;
			item.value = 100000;
			item.rare = 4;
			item.UseSound = SoundID.Item11;
			item.autoReuse = false;
			item.shoot = 10;
			item.shootSpeed = 16f;
			item.useAmmo = AmmoID.Bullet;
			item.UseSound = mod.GetLegacySoundSlot(SoundType.Item, "Sounds/Item/sound");
		}				
		public override bool ConsumeAmmo(Player player)
		{
			return Main.rand.NextFloat() >= .25f;
		}

		public override bool Shoot(Player player, ref Vector2 position, ref float speedX, ref float speedY, ref int type, ref int damage, ref float knockBack)
		{
			Vector2 perturbedSpeed = new Vector2(speedX, speedY).RotatedByRandom(MathHelper.ToRadians(2));
			speedX = perturbedSpeed.X;
			speedY = perturbedSpeed.Y;
			return true;
		}

		public override Vector2? HoldoutOffset()
		{
			return new Vector2(6, 1);
		}

		public override void AddRecipes()
		{
			ModRecipe recipe = new ModRecipe(mod);
			recipe.AddIngredient(mod.GetItem("P05Mark2A"));
			recipe.AddIngredient(ItemID.MechanicalEye, 1);
			recipe.AddIngredient(ItemID.MechanicalWorm, 1);
			recipe.AddIngredient(ItemID.MechanicalSkull, 1);
			recipe.AddTile(TileID.Anvils);
			recipe.SetResult(this);
			recipe.AddRecipe();
		}
	}
}